annotate test/test-server.sh @ 143:a9be6f1e680d

Don't try to validate if schema dir not found (avoiding lengthy errors)
author Chris Cannam <c.cannam@qmul.ac.uk>
date Wed, 18 Jan 2017 14:19:12 +0000
parents 3ae0335cfe60
children
rev   line source
c@75 1 #!/bin/bash
c@75 2
c@75 3 set -eu
c@75 4
c@75 5 piperdir=../piper
c@75 6 vampsdkdir=../vamp-plugin-sdk
c@75 7 schemadir="$piperdir"/json/schema
c@75 8
c@143 9 if [ ! -d "$schemadir" ]; then
c@143 10 echo "WARNING: schema directory $schemadir not found, won't be validating JSON schema" 1>&2
c@143 11 fi
c@143 12
c@116 13 tmpdir=$(mktemp -d)
c@116 14
c@116 15 if [ ! -d "$tmpdir" ]; then
c@116 16 echo "Temp directory creation failed" 1>&2
c@116 17 exit 1
c@116 18 fi
c@116 19
c@116 20 trap "rm -rf $tmpdir" 0
c@116 21
c@116 22 reqfile="$tmpdir/req.json"
c@116 23 respfile="$tmpdir/resp.json"
c@116 24 allrespfile="$tmpdir/resp.all"
c@116 25 input="$tmpdir/input"
c@116 26 expected="$tmpdir/expected"
c@116 27 obtained="$tmpdir/obtained"
c@75 28
c@75 29 validate() {
c@75 30 local file="$1"
c@75 31 local schemaname="$2"
c@143 32 if [ -d "$schemadir" ]; then
c@143 33 jsonschema -i "$file" "$schemadir/$schemaname.json" 1>&2 && \
c@143 34 echo "validated $schemaname" 1>&2 || \
c@143 35 echo "failed to validate $schemaname" 1>&2
c@143 36 else
c@143 37 echo "schema directory $schemadir not found, skipping validation" 1>&2
c@143 38 fi
c@75 39 }
c@75 40
c@75 41 validate_request() {
c@75 42 local json="$1"
c@75 43 echo "$json" > "$reqfile"
c@75 44 validate "$reqfile" "rpcrequest"
c@75 45 }
c@75 46
c@75 47 validate_response() {
c@75 48 local json="$1"
c@75 49 echo "$json" > "$respfile"
c@75 50 validate "$respfile" "rpcresponse"
c@75 51 }
c@75 52
c@116 53 cat > "$input" <<EOF
c@75 54 {"method":"list"}
c@127 55 {"method":"list","params": {"from":["vamp-example-plugins","something-nonexistent"]}}
c@127 56 {"method":"list","params": {"from":["something-nonexistent"]}}
c@75 57 {"method":"load","id":6,"params": {"key":"vamp-example-plugins:percussiononsets","inputSampleRate":44100,"adapterFlags":["AdaptInputDomain","AdaptBufferSize"]}}
c@75 58 {"method":"configure","id":"weevil","params":{"handle":1,"configuration":{"blockSize": 8, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 8}}}
c@75 59 {"method":"process","params": {"handle": 1, "processInput": { "timestamp": {"s": 0, "n": 0}, "inputBuffers": [ [1,2,3,4,5,6,7,8] ]}}}
c@75 60 {"method":"finish","params": {"handle": 1}}
c@75 61 EOF
c@75 62
c@75 63 # Expected output, apart from the plugin list which seems a bit
c@75 64 # fragile to check here
c@75 65 cat > "$expected" <<EOF
c@75 66 {"id": 6, "jsonrpc": "2.0", "method": "load", "result": {"defaultConfiguration": {"blockSize": 1024, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 1024}, "handle": 1, "staticData": {"basic": {"description": "Detect percussive note onsets by identifying broadband energy rises", "identifier": "percussiononsets", "name": "Simple Percussion Onset Detector"}, "basicOutputInfo": [{"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}], "category": ["Time", "Onsets"], "copyright": "Code copyright 2006 Queen Mary, University of London, after Dan Barry et al 2005. Freely redistributable (BSD license)", "inputDomain": "TimeDomain", "key": "vamp-example-plugins:percussiononsets", "maker": "Vamp SDK Example Plugins", "maxChannelCount": 1, "minChannelCount": 1, "parameters": [{"basic": {"description": "Energy rise within a frequency bin necessary to count toward broadband total", "identifier": "threshold", "name": "Energy rise threshold"}, "defaultValue": 3, "extents": {"max": 20, "min": 0}, "unit": "dB", "valueNames": []}, {"basic": {"description": "Sensitivity of peak detector applied to broadband detection function", "identifier": "sensitivity", "name": "Sensitivity"}, "defaultValue": 40, "extents": {"max": 100, "min": 0}, "unit": "%", "valueNames": []}], "programs": [], "version": 2}}}
c@75 67 {"id": "weevil", "jsonrpc": "2.0", "method": "configure", "result": {"handle": 1, "outputList": [{"basic": {"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, "configured": {"binCount": 0, "binNames": [], "hasDuration": false, "sampleRate": 44100, "sampleType": "VariableSampleRate", "unit": ""}}, {"basic": {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}, "configured": {"binCount": 1, "binNames": [""], "hasDuration": false, "quantizeStep": 1, "sampleRate": 86.1328125, "sampleType": "FixedSampleRate", "unit": ""}}]}}
c@75 68 {"jsonrpc": "2.0", "method": "process", "result": {"features": {}, "handle": 1}}
c@75 69 {"jsonrpc": "2.0", "method": "finish", "result": {"features": {"detectionfunction": [{"featureValues": [0], "timestamp": {"n": 11609977, "s": 0}}]}, "handle": 1}}
c@75 70 EOF
c@75 71
c@116 72 # We run the whole test twice, once with the server in Capnp mode
c@116 73 # (converting to JSON using piper-convert) and once with it directly
c@116 74 # in JSON mode
c@75 75
c@129 76 for format in json capnp ; do
c@75 77
c@117 78 ( export VAMP_PATH="$vampsdkdir"/examples ;
c@117 79 while read request ; do
c@116 80 validate_request "$request"
c@116 81 echo "$request"
c@116 82 done |
c@116 83 if [ "$format" = "json" ]; then
c@125 84 bin/piper-vamp-simple-server -d json
c@116 85 else
c@116 86 bin/piper-convert request -i json -o capnp |
c@125 87 bin/piper-vamp-simple-server -d capnp |
c@116 88 bin/piper-convert response -i capnp -o json
c@116 89 fi |
c@116 90 while read response ; do
c@116 91 echo "$response" >> "$allrespfile"
c@116 92 validate_response "$response"
c@116 93 done
c@116 94 ) < "$input"
c@116 95
c@127 96 # Skip plugin lists
c@127 97 tail -n +4 "$allrespfile" > "$obtained"
c@116 98
c@116 99 echo "Checking response contents against expected contents..."
c@116 100 if ! cmp "$obtained" "$expected"; then
c@116 101 diff -u1 "$obtained" "$expected"
c@116 102 else
c@116 103 echo "OK"
c@116 104 fi
c@116 105
c@127 106 echo "Checking plugin counts from list responses..."
c@127 107
c@127 108 # Now check the plugin lists, but as the descriptions etc are
c@127 109 # probably a bit fragile, let's just count the number of plugins
c@127 110
c@127 111 # First, with no "from" arg to the list call
c@127 112 list_no_from=$(head -n +1 "$allrespfile" | fmt -1 | grep '"key"' | wc -l)
c@127 113
c@127 114 # Now with a "from" arg that includes the library that exists
c@127 115 list_with_good_from=$(tail -n +2 "$allrespfile" | head -n +1 | fmt -1 |
c@127 116 grep '"key"' | wc -l)
c@127 117
c@127 118 # Now with a "from" arg that doesn't include any real library
c@127 119 list_with_bad_from=$(tail -n +3 "$allrespfile" | head -n +1 | fmt -1 |
c@127 120 grep '"key"' | wc -l)
c@127 121
c@127 122 if [ "$list_no_from" != "6" ]; then
c@127 123 echo "Wrong number of plugins from list response without \"from\" arg"
c@127 124 echo "Expected 6, obtained $list_no_from"
c@127 125 false
c@127 126 fi
c@127 127 if [ "$list_with_good_from" != "6" ]; then
c@127 128 echo "Wrong number of plugins from list response with good \"from\" arg"
c@127 129 echo "Expected 6, obtained $list_with_good_from"
c@127 130 false
c@127 131 fi
c@127 132 if [ "$list_with_bad_from" != "0" ]; then
c@127 133 echo "Wrong number of plugins from list response with bad \"from\" arg"
c@127 134 echo "Expected 0, obtained $list_with_bad_from"
c@127 135 false
c@127 136 fi
c@127 137 echo OK
c@127 138
c@116 139 rm "$allrespfile"
c@116 140
c@116 141 done
c@127 142
c@127 143 echo "Tests succeeded" # set -e at top should ensure we don't get here otherwise